commit 2b3c8cc1f29d4786c42d46dc793c1bcb40f657fd
Author: Assos Assos <assos+forge@centrale-marseille.fr>
Date:   Wed Jul 15 22:46:25 2015 +0200

    Weekly update of contrib modules

diff --git a/drupal7/sites/all/modules/file_entity/file_entity.admin.inc b/drupal7/sites/all/modules/file_entity/file_entity.admin.inc
index 0e09e451..41c7c93b 100644
--- a/drupal7/sites/all/modules/file_entity/file_entity.admin.inc
+++ b/drupal7/sites/all/modules/file_entity/file_entity.admin.inc
@@ -331,6 +331,8 @@ function file_entity_admin_files() {
   $query = db_select('file_managed', 'fm')->extend('PagerDefault')->extend('TableSort');
   $query->leftJoin('file_usage', 'fu', 'fm.fid = fu.fid');
   $query->groupBy('fm.fid');
+  $query->groupBy('fm.uid');
+  $query->groupBy('fm.timestamp');
   $query->addExpression('SUM(fu.count)', 'total_count');
   file_entity_build_filter_query($query);
 
@@ -354,6 +356,7 @@ function file_entity_admin_files() {
   $options = array();
   foreach ($files as $file) {
     $file_type = file_type_load($file->type);
+    $account = isset($accounts[$file->uid]) ? $accounts[$file->uid] : NULL;
     $options[$file->fid] = array(
       'title' => array(
         'data' => array(
@@ -364,7 +367,7 @@ function file_entity_admin_files() {
       ),
       'type' => $file_type ? check_plain($file_type->label) : FILE_TYPE_NONE,
       'size' => format_size($file->filesize),
-      'author' => theme('username', array('account' => $accounts[$file->uid])),
+      'author' => theme('username', array('account' => $account)),
       'timestamp' => format_date($file->timestamp, 'short'),
       'usage' => format_plural((int) $result[$file->fid]->total_count, '1 place', '@count places'),
     );
diff --git a/drupal7/sites/all/modules/file_entity/file_entity.field.inc b/drupal7/sites/all/modules/file_entity/file_entity.field.inc
index 2a3700c1..4b039b63 100644
--- a/drupal7/sites/all/modules/file_entity/file_entity.field.inc
+++ b/drupal7/sites/all/modules/file_entity/file_entity.field.inc
@@ -36,6 +36,7 @@ function file_entity_field_formatter_info() {
       'controls' => TRUE,
       'autoplay' => FALSE,
       'loop' => FALSE,
+      'preload' => '',
       'multiple_file_behavior' => 'tags',
     ),
     'file formatter' => array(
@@ -53,6 +54,7 @@ function file_entity_field_formatter_info() {
       'muted' => FALSE,
       'width' => NULL,
       'height' => NULL,
+      'preload' => '',
       'multiple_file_behavior' => 'tags',
     ),
     'file formatter' => array(
@@ -131,6 +133,13 @@ function file_entity_field_formatter_settings_form($field, $instance, $view_mode
       '#type' => 'checkbox',
       '#default_value' => $settings['loop'],
     );
+    $element['preload'] = array(
+      '#title' => t('Preload'),
+      '#type' => 'select',
+      '#default_value' => $settings['preload'],
+      '#options' => drupal_map_assoc(array('none', 'auto', 'metadata')),
+      '#empty_option' => 'unspecified',
+    );
     $element['multiple_file_behavior'] = array(
       '#title' => t('Display of multiple files'),
       '#type' => 'radios',
@@ -181,6 +190,13 @@ function file_entity_field_formatter_settings_form($field, $instance, $view_mode
       '#maxlength' => 5,
       '#field_suffix' => t('pixels'),
     );
+    $element['preload'] = array(
+      '#title' => t('Preload'),
+      '#type' => 'select',
+      '#default_value' => $settings['preload'],
+      '#options' => drupal_map_assoc(array('none', 'auto', 'metadata')),
+      '#empty_option' => 'unspecified',
+    );
     $element['multiple_file_behavior'] = array(
       '#title' => t('Display of multiple files'),
       '#type' => 'radios',
@@ -222,6 +238,9 @@ function file_entity_field_formatter_settings_summary($field, $instance, $view_m
     if (isset($settings['loop'])) {
       $summary[] = t('Loop: %loop', array('%loop' => $settings['loop'] ? t('yes') : t('no')));
     }
+    if (!empty($settings['preload'])) {
+      $summary[] = t('Preload: %preload', array('%preload' => $settings['preload']));
+    }
     if (isset($settings['multiple_file_behavior'])) {
       $summary[] = t('Multiple files: %multiple', array('%multiple' => $settings['multiple_file_behavior']));
     }
@@ -242,6 +261,9 @@ function file_entity_field_formatter_settings_summary($field, $instance, $view_m
     if ($settings['width'] && $settings['height']) {
       $summary[] = t('Size: %width x %height', array('%width' => $settings['width'], '%height' => $settings['height']));
     }
+    if (!empty($settings['preload'])) {
+      $summary[] = t('Preload: %preload', array('%preload' => $settings['preload']));
+    }
     if (isset($settings['multiple_file_behavior'])) {
       $summary[] = t('Multiple files: %multiple', array('%multiple' => $settings['multiple_file_behavior']));
     }
@@ -357,6 +379,7 @@ function file_entity_field_formatter_view($entity_type, $entity, $field, $instan
         '#controls' => $settings['controls'],
         '#autoplay' => $settings['autoplay'],
         '#loop' => $settings['loop'],
+        '#preload' => $settings['preload'],
       );
     }
   }
@@ -394,6 +417,7 @@ function file_entity_field_formatter_view($entity_type, $entity, $field, $instan
         '#muted' => $settings['muted'],
         '#width' => $settings['width'],
         '#height' => $settings['height'],
+        '#preload' => $settings['preload'],
       );
     }
   }
diff --git a/drupal7/sites/all/modules/file_entity/file_entity.file.inc b/drupal7/sites/all/modules/file_entity/file_entity.file.inc
index 74feaa6f..c9aab5c0 100644
--- a/drupal7/sites/all/modules/file_entity/file_entity.file.inc
+++ b/drupal7/sites/all/modules/file_entity/file_entity.file.inc
@@ -166,6 +166,7 @@ function file_entity_file_mimetype_mapping_alter(&$mapping) {
  * Implements hook_file_load().
  */
 function file_entity_file_load($files) {
+  // Add alt and title text to images.
   $alt = variable_get('file_entity_alt', '[file:field_file_image_alt_text]');
   $title = variable_get('file_entity_title', '[file:field_file_image_title_text]');
 
@@ -179,17 +180,35 @@ function file_entity_file_load($files) {
 
     // Load alt and title text from fields.
     if (!empty($alt)) {
-      $file->alt = token_replace($alt, array('file' => $file), $replace_options);
+      $output = token_replace($alt, array('file' => $file), $replace_options);
+
+      // @todo Remove once https://www.drupal.org/node/1713164 is fixed.
+      // There is currently no way to get the raw alt text returned from the
+      // token so we revert the encoding done during tokenization.
+      $file->alt = decode_entities($output);
     }
     if (!empty($title)) {
-      $file->title = token_replace($title, array('file' => $file), $replace_options);
+      $output = token_replace($title, array('file' => $file), $replace_options);
+
+      // @todo Remove once https://www.drupal.org/node/1713164 is fixed.
+      // There is currently no way to get the raw title text returned from the
+      // token so we revert the encoding done during tokenization.
+      $file->title = decode_entities($output);
     }
   }
 
   // Load and unserialize metadata.
   $results = db_query("SELECT * FROM {file_metadata} WHERE fid IN (:fids)", array(':fids' => array_keys($files)));
+
   foreach ($results as $result) {
-    $files[$result->fid]->metadata[$result->name] = unserialize($result->value);
+    $name = $result->name;
+
+    // image.module required height and width to be properties of the file.
+    if ($name == 'height' || $name == 'width') {
+      $files[$result->fid]->$name = unserialize($result->value);
+    }
+
+    $files[$result->fid]->metadata[$name] = unserialize($result->value);
   }
 }
 
diff --git a/drupal7/sites/all/modules/file_entity/file_entity.file_default_displays.inc b/drupal7/sites/all/modules/file_entity/file_entity.file_default_displays.inc
index 74ca6609..ccf2376a 100644
--- a/drupal7/sites/all/modules/file_entity/file_entity.file_default_displays.inc
+++ b/drupal7/sites/all/modules/file_entity/file_entity.file_default_displays.inc
@@ -99,7 +99,7 @@ function file_entity_file_default_displays() {
     $file_display = new stdClass();
     $file_display->api_version = 1;
     $file_display->name = 'image__default__file_field_image';
-    $file_display->weight = 49;
+    $file_display->weight = 48;
     $file_display->status = TRUE;
     $file_display->settings = array(
       'image_style' => '',
@@ -111,7 +111,7 @@ function file_entity_file_default_displays() {
     $file_display = new stdClass();
     $file_display->api_version = 1;
     $file_display->name = 'image__preview__file_field_image';
-    $file_display->weight = 49;
+    $file_display->weight = 48;
     $file_display->status = TRUE;
     $file_display->settings = array(
       'image_style' => 'thumbnail',
@@ -123,7 +123,7 @@ function file_entity_file_default_displays() {
     $file_display = new stdClass();
     $file_display->api_version = 1;
     $file_display->name = 'image__teaser__file_field_image';
-    $file_display->weight = 49;
+    $file_display->weight = 48;
     $file_display->status = TRUE;
     $file_display->settings = array(
       'image_style' => 'medium',
diff --git a/drupal7/sites/all/modules/file_entity/file_entity.info b/drupal7/sites/all/modules/file_entity/file_entity.info
index a34997e6..a6c3a15d 100644
--- a/drupal7/sites/all/modules/file_entity/file_entity.info
+++ b/drupal7/sites/all/modules/file_entity/file_entity.info
@@ -1,11 +1,15 @@
-name = File entity
+name = File Entity
 description = "Extends Drupal file entities to be fieldable and viewable."
 package = Media
 core = 7.x
+
 dependencies[] = field
 dependencies[] = file
 dependencies[] = ctools
 dependencies[] = system (>=7.9)
+
+test_dependencies[] = token
+
 files[] = views/views_handler_argument_file_type.inc
 files[] = views/views_handler_field_file_rendered.inc
 files[] = views/views_handler_field_file_type.inc
@@ -20,14 +24,15 @@ files[] = views/views_handler_field_file_link_usage.inc
 files[] = views/views_plugin_row_file_rss.inc
 files[] = views/views_plugin_row_file_view.inc
 files[] = file_entity.test
+
 configure = admin/config/media/file-settings
 
 ; We have to add a fake version so Git checkouts do not fail Media dependencies
 version = 7.x-2.x-dev
 
-; Information added by Drupal.org packaging script on 2014-10-04
-version = "7.x-2.0-beta1"
+; Information added by Drupal.org packaging script on 2015-07-14
+version = "7.x-2.0-beta2"
 core = "7.x"
 project = "file_entity"
-datestamp = "1412420930"
+datestamp = "1436896443"
 
diff --git a/drupal7/sites/all/modules/file_entity/file_entity.install b/drupal7/sites/all/modules/file_entity/file_entity.install
index bbf4b246..feeb2e21 100644
--- a/drupal7/sites/all/modules/file_entity/file_entity.install
+++ b/drupal7/sites/all/modules/file_entity/file_entity.install
@@ -1070,3 +1070,12 @@ function file_entity_update_7215() {
   db_add_primary_key('file_metadata', array('fid', 'name'));
   db_drop_index('file_metadata', 'temp');
 }
+
+/**
+ * This update has been removed and will not run.
+ */
+function file_entity_update_7216() {
+  // This update function previously saved default file displays into the
+  // database. It has been removed due to reported problems and is better
+  // addressed by adding support for ctools default content to features.
+}
diff --git a/drupal7/sites/all/modules/file_entity/file_entity.module b/drupal7/sites/all/modules/file_entity/file_entity.module
index 5d058e4c..f00dacc9 100644
--- a/drupal7/sites/all/modules/file_entity/file_entity.module
+++ b/drupal7/sites/all/modules/file_entity/file_entity.module
@@ -79,6 +79,9 @@ function file_entity_hook_info_alter(&$info) {
     // Miscellaneous hooks
     'file_mimetype_mapping_alter',
     'file_url_alter',
+    // Stream wrappers
+    'stream_wrappers',
+    'stream_wrappers_alter',
   );
   $info += array_fill_keys($hooks, array('group' => 'file'));
 }
@@ -875,6 +878,7 @@ function file_entity_theme() {
         'controls' => TRUE,
         'autoplay' => FALSE,
         'loop' => FALSE,
+        'preload' => NULL,
       ),
       'file' => 'file_entity.theme.inc',
     ),
@@ -887,6 +891,7 @@ function file_entity_theme() {
         'muted' => FALSE,
         'width' => NULL,
         'height' => NULL,
+        'preload' => NULL,
       ),
       'file' => 'file_entity.theme.inc',
     ),
@@ -954,8 +959,8 @@ function file_entity_entity_info_alter(&$entity_info) {
 
   // Ensure some of the Entity API callbacks are supported.
   $entity_info['file']['creation callback'] = 'entity_metadata_create_object';
-  $entity_info['file']['view callback'] = 'file_view_multiple';
-  $entity_info['file']['edit callback'] = 'file_entity_metadata_form_file';
+  $entity_info['file']['view callback'] = 'file_entity_metadata_view_file';
+  $entity_info['file']['form callback'] = 'file_entity_metadata_form_file';
   $entity_info['file']['access callback'] = 'file_entity_access';
 
   // Add integration with the Title module for file name replacement support.
@@ -1023,6 +1028,15 @@ function file_entity_uri($file) {
   return $uri;
 }
 
+/**
+ * Entity API callback to view files.
+ */
+function file_entity_metadata_view_file($entities, $view_mode = 'full', $langcode = NULL) {
+  $result = file_view_multiple($entities, $view_mode, 0, $langcode);
+  // Make sure to key the result with 'file' instead of 'files'.
+  return array('file' => reset($result));
+}
+
 /**
  * Entity API callback to get the form of a file entity.
  */
@@ -1036,10 +1050,9 @@ function file_entity_metadata_form_file($file) {
 /**
  * Implements hook_ctools_plugin_directory().
  */
-
-function file_entity_ctools_plugin_directory($module, $type) {
-  if ($module == 'ctools' && $type == 'content_types') {
-    return 'plugins/' . $type;
+function file_entity_ctools_plugin_directory($module, $plugin) {
+  if (in_array($module, array('panelizer', 'ctools', 'page_manager'))) {
+    return 'plugins/' . $plugin;
   }
 }
 
@@ -1491,6 +1504,7 @@ function file_entity_type_get_names() {
   $names = &drupal_static(__FUNCTION__);
 
   if (!isset($names)) {
+    $names = array();
     $info = entity_get_info('file');
     foreach ($info['bundles'] as $bundle => $bundle_info) {
       $names[$bundle] = $bundle_info['label'];
@@ -1563,11 +1577,11 @@ function file_entity_stream_wrappers_alter(&$wrappers) {
 /**
  * Implements hook_ctools_plugin_api().
  */
-function file_entity_ctools_plugin_api($owner, $api) {
-  if ($owner == 'file_entity' && $api == 'file_type') {
+function file_entity_ctools_plugin_api($module, $api) {
+  if (($module == 'file_entity' && $api == 'file_type') || ($module == 'page_manager' && $api == 'pages_default') || $module == 'panelizer') {
     return array('version' => 1);
   }
-  if ($owner == 'file_entity' && $api == 'file_default_displays') {
+  if ($module == 'file_entity' && $api == 'file_default_displays') {
     return array('version' => 1);
   }
 }
@@ -1955,7 +1969,7 @@ function file_entity_file_download($uri) {
     return file_get_content_headers($file);
   }
 
-  return -1;
+  return NULL;
 }
 
 /**
diff --git a/drupal7/sites/all/modules/file_entity/file_entity.pages.inc b/drupal7/sites/all/modules/file_entity/file_entity.pages.inc
index a00245a9..17688fee 100644
--- a/drupal7/sites/all/modules/file_entity/file_entity.pages.inc
+++ b/drupal7/sites/all/modules/file_entity/file_entity.pages.inc
@@ -165,7 +165,7 @@ function file_entity_add_upload_step_scheme($form, &$form_state, array $options
 
   // Remove any schemes not found in the instance settings.
   if (!empty($options['schemes'])) {
-    $schemes = array_intersect_key($schemes, $options['schemes']);
+    $schemes = array_intersect_key($schemes, array_flip($options['schemes']));
   }
 
   // Determine which scheme to use as the default value.
@@ -245,58 +245,54 @@ function file_entity_usage_page($file) {
   $rows = array();
   $occured_entities = array();
 
-  foreach (file_usage_list($file) as $module => $usage) {
-    $info = system_get_info('module', $module);
-
-    // There are cases where the actual entity doesn't exist.
-    // We have to handle this.
-    foreach ($usage as $entity_type => $entity_ids) {
+  // Determine all of the locations where a file is used, then loop through the
+  // occurrences and filter out any duplicates.
+  foreach (file_usage_list($file) as $module => $type) {
+    foreach ($type as $entity_type => $entity_ids) {
+      // There are cases where the actual entity doesn't exist.
+      // We have to handle this.
       $entity_info = entity_get_info($entity_type);
       $entities = empty($entity_info) ? NULL : entity_load($entity_type, array_keys($entity_ids));
 
       foreach ($entity_ids as $entity_id => $count) {
-        // If some other module already added this entity just sum all counts.
+        // If this entity has already been listed in the table, just add any
+        // additional usage to the total count column in the table row and
+        // continue on to the next iteration of the loop.
         if (isset($occured_entities[$entity_type][$entity_id])) {
           $rows[$occured_entities[$entity_type][$entity_id]][2] += $count;
           continue;
         }
 
+        // Retrieve the label and the URI of the entity.
         $label = empty($entities[$entity_id]) ? $module : entity_label($entity_type, $entities[$entity_id]);
         $entity_uri = empty($entities[$entity_id]) ? NULL : entity_uri($entity_type, $entities[$entity_id]);
 
-        // Some entities do not have URL.
+        // Link the label to the URI when possible.
         if (empty($entity_uri)) {
-          $rows[] = array(check_plain($label), $entity_type, $module, $count);
+          $entity = check_plain($label);
         }
         else {
-          $uri = $entity_uri['path'];
-          $rows[] = array(l($label, $uri), $entity_type, $module, $count);
+          $entity = l($label, $entity_uri['path']);
         }
 
+        $rows[] = array($entity, $entity_type, $count);
+
+        // Record the occurrence of the entity to ensure that it isn't listed in
+        // the table again.
         $occured_entities[$entity_type][$entity_id] = count($rows) - 1;
       }
     }
   }
-  $header[] = array(
-    'data' => t('Entity'),
-  );
-  $header[] = array(
-    'data' => t('Entity type'),
-  );
-  $header[] = array(
-    'data' => t('Registering module'),
-  );
-  $header[] = array(
-    'data' => t('Use count'),
-  );
+
+  $header = array(t('Entity'), t('Entity type'), t('Use count'));
   $build['usage_table'] = array(
     '#theme' => 'table',
     '#header' => $header,
     '#rows' => $rows,
-    '#caption' => t('This table lists all of the places where @filename is used.',
-    array('@filename' => $file->filename)),
+    '#caption' => t('This table lists all of the places where @filename is used.', array('@filename' => $file->filename)),
     '#empty' => t('This file is not currently used.'),
   );
+
   return $build;
 }
 
@@ -428,7 +424,9 @@ function file_entity_add_upload_submit($form, &$form_state) {
     $file = file_load($form_state['storage']['upload']);
     if ($file) {
       if (file_uri_scheme($file->uri) != $form_state['storage']['scheme']) {
-        if ($moved_file = file_move($file, $form_state['storage']['scheme'] . '://' . file_uri_target($file->uri), FILE_EXISTS_RENAME)) {
+        $file_destination = $form_state['storage']['scheme'] . '://' . file_uri_target($file->uri);
+        $file_destination = file_stream_wrapper_uri_normalize($file_destination);
+        if ($moved_file = file_move($file, $file_destination, FILE_EXISTS_RENAME)) {
           // Only re-assign the file object if file_move() did not fail.
           $file = $moved_file;
         }
@@ -455,17 +453,13 @@ function file_entity_add_upload_submit($form, &$form_state) {
     }
 
     // Figure out destination.
-    if (isset($_GET['destination'])) {
-      $destination = drupal_get_destination();
-      unset($_GET['destination']);
-    }
-    elseif (user_access('administer files')) {
-      $destination = array('destination' => 'admin/content/file');
+    if (user_access('administer files')) {
+      $path = 'admin/content/file';
     }
     else {
-      $destination = array('destination' => 'file/' . $file->fid);
+      $path = 'file/' . $file->fid;
     }
-    $form_state['redirect'] = $destination['destination'];
+    $form_state['redirect'] = $path;
   }
   else {
     $form_state['rebuild'] = TRUE;
@@ -558,7 +552,6 @@ function file_entity_add_upload_multiple_submit($form, &$form_state) {
       $file->status = FILE_STATUS_PERMANENT;
       file_save($file);
 
-      $saved_files[] = $file;
       $form_state['files'][$file->fid] = $file;
     }
     else {
@@ -568,7 +561,7 @@ function file_entity_add_upload_multiple_submit($form, &$form_state) {
   }
 
   // Redirect to the file edit page.
-  if (file_entity_access('update', $file) && module_exists('multiform') && module_exists('media')) {
+  if (file_entity_access('update', $file) && module_exists('media_bulk_upload')) {
     $destination = array();
     if (isset($_GET['destination'])) {
       $destination = drupal_get_destination();
@@ -807,7 +800,7 @@ function file_entity_edit_submit($form, &$form_state) {
   if (!empty($form_state['values']['replace_upload'])) {
     $replacement = $form_state['values']['replace_upload'];
     // Move file from temp to permanent home.
-    $destination_uri = file_uri_scheme($file->uri) . '://' . file_uri_target($replacement->uri);
+    $destination_uri = rtrim($file->uri, drupal_basename($file->uri)) . drupal_basename($replacement->uri);
     $replace_mode = $destination_uri == $file->uri ? FILE_EXISTS_REPLACE : FILE_EXISTS_RENAME;
     if ($new_file_uri = file_unmanaged_copy($replacement->uri, $destination_uri, $replace_mode)) {
       // @todo Add watchdog() about replaced file here?
@@ -848,7 +841,9 @@ function file_entity_edit_submit($form, &$form_state) {
   }
 
   if (file_uri_scheme($file->uri) != $form_state['values']['scheme']) {
-    if ($moved_file = file_move($file, $form_state['values']['scheme'] . '://' . file_uri_target($file->uri), FILE_EXISTS_RENAME)) {
+    $file_destination = $form_state['storage']['scheme'] . '://' . file_uri_target($file->uri);
+    $file_destination = file_stream_wrapper_uri_normalize($file_destination);
+    if ($moved_file = file_move($file, $file_destination, FILE_EXISTS_RENAME)) {
       // Only re-assign the file object if file_move() did not fail.
       $file = $moved_file;
     }
